<template>
  <Dialog :title="dialogTitle" v-model="dialogVisible">
    <el-form
      ref="formRef"
      :model="formData"
      :rules="formRules"
      label-width="100px"
      v-loading="formLoading"
    >
      <el-form-item label="所属设备分类" prop="deviceCategoryId">
        <el-input v-model="formData.deviceCategoryId" placeholder="请输入所属设备分类" />
      </el-form-item>
      <el-form-item label="所属设备" prop="deviceId">
        <el-input v-model="formData.deviceId" placeholder="请输入所属设备" />
      </el-form-item>
      <el-form-item label="设备BOM节点名称" prop="name">
        <el-input v-model="formData.name" placeholder="请输入设备BOM节点名称" />
      </el-form-item>
      <el-form-item label="设备BOM节点id" prop="bomNodeId">
        <el-input v-model="formData.bomNodeId" placeholder="请输入设备BOM节点id" />
      </el-form-item>
      <el-form-item label="设备BOM节点编码" prop="code">
        <el-input v-model="formData.code" placeholder="请输入设备BOM节点编码" />
      </el-form-item>
      <el-form-item label="物料id" prop="materialId">
        <el-input v-model="formData.materialId" placeholder="请输入物料id" />
      </el-form-item>
      <el-form-item label="数量" prop="quantity">
        <el-input v-model="formData.quantity" placeholder="请输入数量" />
      </el-form-item>
      <el-form-item label="状态 0启用  1停用" prop="status">
        <el-radio-group v-model="formData.status">
          <el-radio value="1">请选择字典生成</el-radio>
        </el-radio-group>
      </el-form-item>
      <el-form-item label="备注" prop="remark">
        <el-input v-model="formData.remark" placeholder="请输入备注" />
      </el-form-item>
    </el-form>
    <template #footer>
      <el-button @click="submitForm" type="primary" :disabled="formLoading">确 定</el-button>
      <el-button @click="dialogVisible = false">取 消</el-button>
    </template>
  </Dialog>
</template>
<script setup lang="ts">
import { IotDeviceMaterialApi, IotDeviceMaterialVO } from '@/api/pms/iotdevicematerial'

/** PMS 设备BOM物料关联 表单 */
defineOptions({ name: 'IotDeviceMaterialForm' })

const { t } = useI18n() // 国际化
const message = useMessage() // 消息弹窗

const dialogVisible = ref(false) // 弹窗的是否展示
const dialogTitle = ref('') // 弹窗的标题
const formLoading = ref(false) // 表单的加载中：1）修改时的数据加载；2）提交的按钮禁用
const formType = ref('') // 表单的类型：create - 新增；update - 修改
const formData = ref({
  id: undefined,
  deviceCategoryId: undefined,
  deviceId: undefined,
  name: undefined,
  bomNodeId: undefined,
  code: undefined,
  materialId: undefined,
  quantity: undefined,
  status: undefined,
  remark: undefined,
})
const formRules = reactive({
})
const formRef = ref() // 表单 Ref

/** 打开弹窗 */
const open = async (type: string, id?: number) => {
  dialogVisible.value = true
  dialogTitle.value = t('action.' + type)
  formType.value = type
  resetForm()
  // 修改时，设置数据
  if (id) {
    formLoading.value = true
    try {
      formData.value = await IotDeviceMaterialApi.getIotDeviceMaterial(id)
    } finally {
      formLoading.value = false
    }
  }
}
defineExpose({ open }) // 提供 open 方法，用于打开弹窗

/** 提交表单 */
const emit = defineEmits(['success']) // 定义 success 事件，用于操作成功后的回调
const submitForm = async () => {
  // 校验表单
  await formRef.value.validate()
  // 提交请求
  formLoading.value = true
  try {
    const data = formData.value as unknown as IotDeviceMaterialVO
    if (formType.value === 'create') {
      await IotDeviceMaterialApi.createIotDeviceMaterial(data)
      message.success(t('common.createSuccess'))
    } else {
      await IotDeviceMaterialApi.updateIotDeviceMaterial(data)
      message.success(t('common.updateSuccess'))
    }
    dialogVisible.value = false
    // 发送操作成功的事件
    emit('success')
  } finally {
    formLoading.value = false
  }
}

/** 重置表单 */
const resetForm = () => {
  formData.value = {
    id: undefined,
    deviceCategoryId: undefined,
    deviceId: undefined,
    name: undefined,
    bomNodeId: undefined,
    code: undefined,
    materialId: undefined,
    quantity: undefined,
    status: undefined,
    remark: undefined,
  }
  formRef.value?.resetFields()
}
</script>